Attribute VB_Name = "FastcamDllDriver"
Option Explicit

'----------------------------
'CamereControl
'----------------------------
Declare Function CameraControl Lib "Pcc4VB.Dll" (ByVal device_select As Long) As Long
Declare Function GetNumberOfDevice Lib "Pcc4VB.Dll" (ByRef number As Long) As Long
Declare Function Init Lib "Pcc4VB.Dll" (ByVal camera_num As Long) As Long
Declare Function ExitCameraControl Lib "Pcc4VB.Dll" () As Long
Declare Function IsInit Lib "Pcc4VB.Dll" () As Long
Declare Function GetDeviceName Lib "Pcc4VB.Dll" (ByVal name As String) As Long
Declare Function GetDeviceType Lib "Pcc4VB.Dll" (ByRef DeviceType As Long) As Long
Declare Function GetDeviceVersion Lib "Pcc4VB.Dll" (ByRef version As Long) As Long
Declare Function GetCameraMode Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function IsColor Lib "Pcc4VB.Dll" (ByRef color As Long) As Long
Declare Function HaveGammaCorrection Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveGainLevel Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveColorTemperature Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveExternalSyncMode Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveExternalSyncInMode Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveExternalSyncOutMode Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveEdgeEnhancement Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveZoomMode Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveBlockPlay Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveExternalInput Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveExternalOutput Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveMonitorOutMode Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveMCDL Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function HaveIRIG Lib "Pcc4VB.Dll" (ByRef have As Long) As Long
Declare Function SetCameraParams Lib "Pcc4VB.Dll" (ByRef params As CAMERA_PARAMS) As Long
Declare Function SetCameraParamsEx Lib "Pcc4VB.Dll" (ByRef params As CAMERA_PARAMS_EX) As Long
Declare Function SetRecordRate Lib "Pcc4VB.Dll" (ByVal Record_rate As Long) As Long
Declare Function SetShutterSpeed Lib "Pcc4VB.Dll" (ByVal speed As Long) As Long
Declare Function SetTriggerMode Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function SetRandomTriggerNumber Lib "Pcc4VB.Dll" (ByVal number As Long) As Long
Declare Function SetManualTriggerPosition Lib "Pcc4VB.Dll" (ByVal position As Long) As Long
Declare Function SetRandomManualPosition Lib "Pcc4VB.Dll" (ByVal position As Long) As Long
Declare Function SetResolution Lib "Pcc4VB.Dll" (ByVal resolution As Long) As Long
Declare Function SetGammaCorrection Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function SetGainLevel Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function SetColorTemperature Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function SetColorTempUser Lib "Pcc4VB.Dll" (ByVal mode As Long, ByVal r As Long, ByVal g As Long, ByVal b As Long) As Long
Declare Function SetExternalSyncMode Lib "Pcc4VB.Dll" (ByVal ModeOn As Long) As Long
Declare Function SetExternalSyncModeEx Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function SetExternalSyncInMode Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function SetExternalSyncOutMode Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function SetEdgeEnhancementMode Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function SetZoomMode Lib "Pcc4VB.Dll" (ByVal ModeOn As Long) As Long
Declare Function SetExternalInMode Lib "Pcc4VB.Dll" (ByVal port As Long, ByVal mode As Long) As Long
Declare Function SetExternalOutMode Lib "Pcc4VB.Dll" (ByVal port As Long, ByVal mode As Long) As Long
Declare Function SetMonitorOutMode Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function SetPartition Lib "Pcc4VB.Dll" (ByVal partition_number As Long) As Long
Declare Function SetPartitionBlockList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function SetExtraCommand Lib "Pcc4VB.Dll" (ByVal command_name As Long, ByVal param1 As Long, ByVal param2 As Long, ByVal param3 As Long, ByVal param4 As Long) As Long
Declare Function GetExtraCommand Lib "Pcc4VB.Dll" (ByVal command_name As Long, ByRef param1 As Long, ByRef param2 As Long, ByRef param3 As Long, ByRef param4 As Long) As Long
Declare Function GetMaxFrame Lib "Pcc4VB.Dll" (ByRef frame As Long) As Long
Declare Function GetFrameParams Lib "Pcc4VB.Dll" (ByRef params As FRAME_PARAMS) As Long
Declare Function GetCameraParams Lib "Pcc4VB.Dll" (ByRef params As CAMERA_PARAMS) As Long
Declare Function GetCameraParamsEx Lib "Pcc4VB.Dll" (ByRef params As CAMERA_PARAMS_EX) As Long
Declare Function UpdateCameraParams Lib "Pcc4VB.Dll" () As Long
Declare Function UpdateCameraParamsEx Lib "Pcc4VB.Dll" () As Long
Declare Function GetRecordRate Lib "Pcc4VB.Dll" (ByRef Record_rate As Long) As Long
Declare Function GetShutterSpeed Lib "Pcc4VB.Dll" (ByRef speed As Long) As Long
Declare Function GetTriggerMode Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetRandomTriggerNumber Lib "Pcc4VB.Dll" (ByRef number As Long) As Long
Declare Function GetManualTriggerPosition Lib "Pcc4VB.Dll" (ByRef position As Long) As Long
Declare Function GetRandomManualPosition Lib "Pcc4VB.Dll" (ByRef position As Long) As Long
Declare Function GetResolution Lib "Pcc4VB.Dll" (ByRef resolution As Long) As Long
Declare Function GetGammaCorrection Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetGainLevel Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetColorTemperature Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetColorTempUser Lib "Pcc4VB.Dll" (ByVal mode As Long, ByRef r As Long, ByRef g As Long, ByRef b As Long) As Long
Declare Function GetExternalSyncMode Lib "Pcc4VB.Dll" (ByRef ModeOn As Long) As Long
Declare Function GetEdgeEnhancementMode Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetZoomMode Lib "Pcc4VB.Dll" (ByRef ModeOn As Long) As Long
Declare Function GetExternalSyncModeEx Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetExternalSyncInMode Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetExternalSyncOutMode Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetExternalInMode Lib "Pcc4VB.Dll" (ByVal port As Long, ByRef mode As Long) As Long
Declare Function GetExternalOutMode Lib "Pcc4VB.Dll" (ByVal port As Long, ByRef mode As Long) As Long
Declare Function GetMonitorOutMode Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetRecordRateList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetShutterSpeedList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetTriggerModeList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetResolutionList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetRandomTriggerNumberList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetColorTemperatureList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetGainLevelList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetGammaCorrectionList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetPartitionInfo Lib "Pcc4VB.Dll" (ByRef max_partition As Long, ByRef max_partition_block As Long, ByRef frame_per_block As Long) As Long
Declare Function GetPartition Lib "Pcc4VB.Dll" (ByRef partition_number As Long) As Long
Declare Function GetPartitionBlockList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function OnLive Lib "Pcc4VB.Dll" (ByVal Liveon As Long) As Long
Declare Function IsLive Lib "Pcc4VB.Dll" (ByRef Liveon As Long) As Long
Declare Function SetCameraNumber Lib "Pcc4VB.Dll" (ByVal number As Long) As Long
Declare Function GetCameraNumber Lib "Pcc4VB.Dll" () As Long
Declare Function OnRecordReady Lib "Pcc4VB.Dll" (ByVal RecordReadyOn As Long) As Long
Declare Function OnRecord Lib "Pcc4VB.Dll" (ByVal RecordOn As Long) As Long
Declare Function IsRecordReady Lib "Pcc4VB.Dll" (ByRef RecordReadyOn As Long) As Long
Declare Function IsRecord Lib "Pcc4VB.Dll" (ByRef RecordOn As Long) As Long
Declare Function IsEndlessRec Lib "Pcc4VB.Dll" (ByRef EndlessRecOn As Long) As Long
Declare Function TriggerIn Lib "Pcc4VB.Dll" () As Long
Declare Function PlayMonitor Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function PauseMonitor Lib "Pcc4VB.Dll" (ByVal PauseOn As Long) As Long
Declare Function StopMonitor Lib "Pcc4VB.Dll" () As Long
Declare Function StepFowardMonitor Lib "Pcc4VB.Dll" () As Long
Declare Function StepBackMonitor Lib "Pcc4VB.Dll" () As Long
Declare Function GoAnyFrameMonitor Lib "Pcc4VB.Dll" (ByVal frame As Long) As Long
Declare Function GoStartMonitor Lib "Pcc4VB.Dll" () As Long
Declare Function GoEndMonitor Lib "Pcc4VB.Dll" () As Long
Declare Function GoTriggerMonitor Lib "Pcc4VB.Dll" () As Long
Declare Function SetPlayRate Lib "Pcc4VB.Dll" (ByVal Play_rate As Long) As Long
Declare Function SetBlockArea Lib "Pcc4VB.Dll" (ByVal startArea As Long, ByVal endArea As Long) As Long
Declare Function SetBlockMode Lib "Pcc4VB.Dll" (ByVal ModeOn As Long) As Long
Declare Function GetPlayRate Lib "Pcc4VB.Dll" (ByRef Play_rate As Long) As Long
Declare Function GetBlockArea Lib "Pcc4VB.Dll" (ByRef startArea As Long, ByRef endArea As Long) As Long
Declare Function GetBlockMode Lib "Pcc4VB.Dll" (ByRef ModeOn As Long) As Long
Declare Function GetTimeCodeFromFrame Lib "Pcc4VB.Dll" (ByRef time_code As IRIGLIB_TIMECODE, ByVal frame As Long) As Long
Declare Function GetDateOfRecording Lib "Pcc4VB.Dll" (ByRef year_at_date As Long, ByRef month_at_date As Long, ByRef day_at_date As Long) As Long
Declare Function GetTimeOfRecording Lib "Pcc4VB.Dll" (ByRef hour_at_time As Long, ByRef minute_at_time As Long, ByRef second_at_time As Long) As Long
Declare Function GetRandCenterManualFrames Lib "Pcc4VB.Dll" (ByRef Times As Long, ByRef frame As Long) As Long
Declare Sub GetIICycleRange Lib "Pcc4VB.Dll" (ByRef dwMin As Long, ByRef dwMax As Long)
Declare Sub GetIIWidthRange Lib "Pcc4VB.Dll" (ByRef dwMin As Long, ByRef dwMax As Long)
Declare Sub GetIIDelayRange Lib "Pcc4VB.Dll" (ByRef dwMin As Long, ByRef dwMax As Long)
Declare Sub GetIITimesRange Lib "Pcc4VB.Dll" (ByRef dwMin As Long, ByRef dwMax As Long)
Declare Sub SetIIPowerSafetyParam Lib "Pcc4VB.Dll" (ByVal nBaseValue As Long, ByRef pValue As Long, ByVal nMode As Long, ByVal nEnable As Long)
Declare Function TransferFrame Lib "Pcc4VB.Dll" (ByVal frame As Long, ByRef buff As Byte) As Long
Declare Function TransferRawBayer Lib "Pcc4VB.Dll" (ByVal frame As Long, ByRef buff As Byte) As Long
Declare Function Transfer16BitFrame Lib "Pcc4VB.Dll" (ByVal frame As Long, ByRef buff As Byte) As Long
Declare Function Transfer16BitRawBayer Lib "Pcc4VB.Dll" (ByVal frame As Long, ByRef buff As Byte) As Long
Declare Function TransferMCDL Lib "Pcc4VB.Dll" (ByVal frame As Long, ByRef buff As Byte) As Long
Declare Function GetEnableMCDL Lib "Pcc4VB.Dll" (ByRef MCDLOn As Long) As Long
Declare Function SetEnableMCDL Lib "Pcc4VB.Dll" (ByVal MCDLOn As Long) As Long
Declare Function TransferIRIG Lib "Pcc4VB.Dll" (ByVal frame As Long, ByRef buff As Byte) As Long
Declare Function GetEnableIRIG Lib "Pcc4VB.Dll" (ByRef IRIGOn As Long) As Long
Declare Function SetEnableIRIG Lib "Pcc4VB.Dll" (ByVal IRIGOn As Long) As Long
Declare Function ShadingCompensation Lib "Pcc4VB.Dll" () As Long
Declare Function GetHeadName Lib "Pcc4VB.Dll" (ByVal name As String, ByVal no As Long) As Long
Declare Function GetVariableRateList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetVariableMaxResolution Lib "Pcc4VB.Dll" (ByVal nFrame As Long, ByRef nWidth As Long, ByRef nHeight As Long) As Long
Declare Function GetVariableMaxWidth Lib "Pcc4VB.Dll" (ByVal nFrame As Long, ByVal nHeight As Long, ByRef nWidth As Long) As Long
Declare Function GetVariableMaxHeight Lib "Pcc4VB.Dll" (ByVal nFrame As Long, ByVal nWidth As Long, ByRef nHeight As Long) As Long
Declare Function GetVariableMaxFrameRate Lib "Pcc4VB.Dll" (ByVal nWidth As Long, ByVal nHeight As Long, ByRef nRate As Long) As Long
Declare Function GetVariableSetting Lib "Pcc4VB.Dll" (ByVal nChannel As Long, ByRef nFrameRate As Long, ByRef nWidth As Long, ByRef nHeight As Long, ByRef nXPos As Long, ByRef nYPos As Long) As Long
Declare Function SetVariableSetting Lib "Pcc4VB.Dll" (ByVal nChannel As Long, ByVal nFrameRate As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal nXPos As Long, ByVal nYPos As Long) As Long
Declare Function GetVariableCamMode Lib "Pcc4VB.Dll" (ByRef nMode As Long, ByRef nChannel As Long) As Long
Declare Function SetGeometricConvert Lib "Pcc4VB.Dll" (ByVal mode As Long) As Long
Declare Function GetGeometricConvert Lib "Pcc4VB.Dll" (ByRef mode As Long) As Long
Declare Function GetShutterSpeedType2List Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listSize As Long) As Long
Declare Function GetShutterSpeedType2 Lib "Pcc4VB.Dll" (ByRef speed As Long) As Long
Declare Function SetAutoExposure Lib "Pcc4VB.Dll" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nXPos As Long, ByVal nYPos As Long, ByVal nValue As Long, ByVal nRange As Long) As Long
Declare Function GetAutoExposureArea Lib "Pcc4VB.Dll" (ByRef nWidth As Long, ByRef nHeight As Long, ByRef nXPos As Long, ByRef nYPos As Long) As Long
Declare Function GetAutoExposureParam Lib "Pcc4VB.Dll" (ByRef nValue As Long, ByRef nRange As Long) As Long
Declare Function GetShutterSpeedAEList Lib "Pcc4VB.Dll" (ByRef list As Long, ByVal listsize As Long, ByRef listnum As Long) As Long)
Declare Function SetGEtherConfig Lib "Pcc4VB.Dll", (ByVal PacketSize As Long, ByVal SendPort As Long, ByVal ReceivePort As Long, ByVal ConnectMode As Long) As Long
Declare Function GetGEtherConfig Lib "Pcc4VB.Dll", (ByRef PacketSize As Long, ByRef SendPort As Long, ByRef ReceivePort As Long, ByRef ConnectMode As Long) As Long


'----------------------------
'ImageData
'----------------------------
Declare Function ImageData Lib "Pcc4VB.Dll" () As Long
Declare Function InitImageData Lib "Pcc4VB.Dll" (ByVal buffer_size As Long) As Long
Declare Function ExitImageData Lib "Pcc4VB.Dll" () As Long
Declare Function SetBmpInfo Lib "Pcc4VB.Dll" (ByRef bmpinfo As BITMAPINFO) As Long
Declare Function GetBmpInfo Lib "Pcc4VB.Dll" (ByRef bmpinfo As BITMAPINFO) As Long
Declare Sub GetImageSize Lib "Pcc4VB.Dll" (ByRef width As Long, ByRef height As Long)
Declare Function GetWindowsImage Lib "Pcc4VB.Dll" (ByRef image As Byte, ByRef buff As Byte, ByRef bmpinfo As BITMAPINFO) As Long
Declare Function GetWindows16BitImage Lib "Pcc4VB.Dll" (ByRef image As Byte, ByRef buff As Byte, ByRef bmpinfo As BITMAPINFO) As Long
Declare Function SetImageNumber Lib "Pcc4VB.Dll" (ByVal number As Long) As Long
Declare Function GetImageNumber Lib "Pcc4VB.Dll" () As Long
Declare Function SetImageData Lib "Pcc4VB.Dll" (ByRef image As Byte) As Long
Declare Function GetImageData Lib "Pcc4VB.Dll" (ByRef image As Byte) As Long
Declare Function LoadFile Lib "Pcc4VB.Dll" (ByVal filename As String) As Long
Declare Function LoadRawFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal size_header As Long, ByVal width As Long, ByVal height As Long, ByVal plane As Long, ByVal interleave As Long) As Long
Declare Function LoadRawwFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal size_header As Long, ByVal width As Long, ByVal height As Long, ByVal plane As Long, ByVal interleave As Long) As Long
Declare Function SaveFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal compress As Long, ByVal comp_quality As Long, ByVal ascii As Long) As Long
Declare Function SaveBmpFile Lib "Pcc4VB.Dll" (ByVal filename As String) As Long
Declare Function SaveTiffFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal compress As Long) As Long
Declare Function SaveJpegFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal quality As Long) As Long
Declare Function SavePnmFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal ascii As Long) As Long
Declare Function SaveRawFile Lib "Pcc4VB.Dll" (ByVal filename As String) As Long
Declare Function SaveRawwFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal bit_depth As Long, ByVal bit_side As Long, ByRef buff As Byte) As Long
Declare Function SavePngFile Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal comp_mode As Long, ByVal depth As Long) As Long
Declare Function SaveFtifFile Lib "Pcc4VB.Dll" (ByVal filename As String) As Long
Declare Function ReAllocateBuffer Lib "Pcc4VB.Dll" (ByVal buffer_size As Long, ByVal surely As Long) As Long
Declare Function ReAllocate16BitBuffer Lib "Pcc4VB.Dll" (ByVal buffer_size As Long, ByVal surely As Long) As Long
Declare Function Is16BitImage Lib "Pcc4VB.Dll" () As Long
Declare Sub InitLut Lib "Pcc4VB.Dll" ()
Declare Sub SetUseLut Lib "Pcc4VB.Dll" (ByVal UseLutOn As Long)
Declare Function GetUseLut Lib "Pcc4VB.Dll" () As Long
Declare Sub SetLutR Lib "Pcc4VB.Dll" (ByRef lut As Long)
Declare Sub SetLutG Lib "Pcc4VB.Dll" (ByRef lut As Long)
Declare Sub SetLutB Lib "Pcc4VB.Dll" (ByRef lut As Long)
Declare Sub GetLutR Lib "Pcc4VB.Dll" (ByRef lut As Long)
Declare Sub GetLutG Lib "Pcc4VB.Dll" (ByRef lut As Long)
Declare Sub GetLutB Lib "Pcc4VB.Dll" (ByRef lut As Long)
Declare Sub SetLut Lib "Pcc4VB.Dll" (ByRef lut As Long, ByVal plane As Long)
Declare Sub GetLut Lib "Pcc4VB.Dll" (ByRef lut As Long, ByVal plane As Long)
Declare Sub SetLutGamma Lib "Pcc4VB.Dll" (ByVal gamma As Double, ByVal plane As Long)
Declare Sub SetLutContrast Lib "Pcc4VB.Dll" (ByVal contrast As Long, ByVal plane As Long)
Declare Sub SetLutBrightness Lib "Pcc4VB.Dll" (ByVal brightness As Long, ByVal plane As Long)
Declare Function GetLutGamma Lib "Pcc4VB.Dll" (ByVal plane As Long) As Double
Declare Function GetLutContrast Lib "Pcc4VB.Dll" (ByVal plane As Long) As Long
Declare Function GetLutBrightness Lib "Pcc4VB.Dll" (ByVal plane As Long) As LongDeclare Function SaveTiffFileEx Lib "Pcc4VB.Dll" (ByVal filename As String, ByVal compress As Long, ByVal depth As Long) As Long

Type CAMERA_PARAMS
        enable_random_trigger As Long
        enable_manual_trigger As Long
        enable_random_manual As Long
        enable_gamma As Long
        enable_gain As Long
        enable_external_sync As Long
        enable_external_sync_in As Long
        enable_external_sync_out As Long
        enable_external_in As Long
        enable_external_out As Long
        enable_color_temp As Long

        camera_type(63) As Byte
        device_name(63) As Byte
        device_type As Long

        device_version As Long
        color As Long

        session_number As Long
        max_frame_num As Long

        camera_mode As Long

        is_live As Long
        is_record_ready As Long

        Record_rate As Long
        resolution As Long
        shutter_speed As Long

        trigger_mode As Long
        trigger_frame As Long
        random_trigger_num As Long
        manual_trigger_frame As Long
        random_trigger_times As Long
        max_random_times As Long
        random_manual_frame As Long
        twostage_lowtohigh_frame As Long
        twostage_hightolow_frame As Long
        twostage_lowtohigh_timing As Long
        gamma_value As Long
        gain_level As Long
        external_sync As Long
        external_sync_nega As Long
        color_temp_mode As Long
        external_sync_in As Long
        external_sync_out As Long
        
        record_rate_num As Long
        resolution_num As Long
        shutter_num As Long
        trigger_mode_num As Long
        random_number_num As Long
        external_in_num As Long
        external_out_num As Long
        color_temp_mode_num As Long
        color_temp_user_num As Long
        gain_level_num As Long
        gamma_value_num As Long

        record_rate_list(LIST_MAX_NUMBER - 1) As Long
        resolution_list(LIST_MAX_NUMBER - 1) As Long
        shutter_list(LIST_MAX_NUMBER - 1) As Long
        trigger_mode_list(LIST_MAX_NUMBER - 1) As Long
        random_number_list(LIST_MAX_NUMBER - 1) As Long
        external_in(LIST_MAX_NUMBER - 1) As Long
        external_out(LIST_MAX_NUMBER - 1) As Long
        color_temp_mode_list(LIST_MAX_NUMBER - 1) As Long
        color_temp_user(LIST_MAX_NUMBER - 1, 2) As Long
        gain_level_list(LIST_MAX_NUMBER - 1) As Long
        gamma_value_list(LIST_MAX_NUMBER - 1) As Long

        enable_mcdl As Long
        enable_monitor_out As Long
        enable_monitor_out_mode As Long
        enable_monitor_edge As Long
        enable_monitor_zoom As Long
        enable_irig As Long
        enable_restriction_time As Long
        monitor_block_on As Long
        monitor_block_start As Long
        monitor_block_end As Long
        monitor_play_rate As Long
        monitor_out_mode As Long
        monitor_edge_mode As Long
        monitor_zoom_on As Long
        mcdl_on As Long
        irig_on As Long
        restriction_time_on As Long

        exist_variablefunc As Long
        variable_channel As Long
        save_step As Long;
End Type

Type CAMERA_PARAMS_EX
        exist_mcdl As Long
        exist_monitor_out As Long
        exist_monitor_out_mode As Long
        exist_monitor_edge As Long
        exist_monitor_zoom As Long
        exist_irig As Long
        exist_restriction_time As Long
        exist_pdc As Long
        exist_device_id As Long
        exist_reset_trigger As Long
        exist_sensor_bitshift As Long
        exist_partition As Long
        exist_geometric_conversion As Long
        exist_shading_compensation As Long
        exist_live_resolution As Long
        exist_lut_mode As Long
        exist_user_lut As Long
        exist_chroma_mode As Long
        exist_ds_shutter As Long

        monitor_block_on As Long
        monitor_block_start As Long
        monitor_block_end As Long
        monitor_play_rate As Long
        monitor_out_mode As Long
        monitor_edge_mode As Long
        monitor_zoom_on As Long
        mcdl_on As Long
        irig_on As Long
        restriction_time_on As Long
        pdc_on As Long
        device_id As Long
        reset_trigger_on As Long
        sensor_bitshift As Long
        max_partition_num As Long
        max_partition_block_num As Long
        partition_frame_per_block As Long
        current_partition As Long
        partition_num As Long
        partition_size_list(255) As Long
        geometric_conversion_mode As Long
        shading_compensation_mode As Long
        live_resolution_mode As Long
        lut_mode As Long
        chroma_mode As Long
        ds_shutter As Long
        irig_offset As Long

        exist_irig_offset As Long
        exist_hard_partition As Long
        hard_partition As Long

        II_POWER_ON As Long
        II_gain As Long
        II_gate_select As Long
        II_gate_cycle As Long
        II_gate_width As Long
        II_gate_times As Long
        II_gate_delay As Long
        II_gain_limit As Long
        exist_ii As Long

        shutter_mode As Long
        exist_shutter_mode As Long

        exist_event_frame As Long
        head_total_num As Long
        current_head As Long

        exist_edge_enhancement As Long
        edge_enhancement As Long

        exist_shutter_type2 As Long
        shutter_type2_list(127) As Long
        shutter_speed_type2 As Long
        color_matrix_rr As Long
        color_matrix_rg As Long
        color_matrix_rb As Long
        color_matrix_gr As Long
        color_matrix_gg As Long
        color_matrix_gb As Long
        color_matrix_br As Long
        color_matrix_bg As Long
        color_matrix_bb As Long
        exist_color_matrix As Long
        color_matrix As Long

        exist_auto_exposure As Long
        auto_exposure As Long
        auto_exposure_reso As Long
        auto_exposure_pos As Long
        auto_exposure_value As Long
        auto_exposure_range As Long
        auto_exposure_maxshutter As Long

        exist_ii_protection As Long
        II_protection As Long
End Type

Type FRAME_PARAMS
        frame_start As Long
        frame_end As Long
        frame_total As Long
        area_start As Long
        area_end As Long
        area_total As Long
        current As Long
        trigger As Long
        key As Long
End Type

Type TIME_PARAMS
        time_start As Double
        time_end As Double
        time_total As Double
        area_start As Double
        area_end As Double
        area_total As Double
        current As Double
        trigger As Double
        key As Double
End Type

Type MCDL_PARAMS
        digital(10) As Byte
        analog_a(10) As Single
        analog_b(10) As Single
        analog_c(10) As Single
        analog_d(10) As Single
End Type

Type IRIGLIB_TIMECODE
        year As Long
        month As Byte
        day As Byte
        day_of_year As Long
        hour As Byte
        minute As Byte
        second As Byte
        below_second As Long
End Type

Type tagBITMAPINFOHEADER
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeimage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Type tagRGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Type BITMAPINFO
        BitmapInfoHeader As tagBITMAPINFOHEADER
        rgbquad(1023) As Byte
End Type


Type TM
        tm_sec As Long
        tm_min As Long
        tm_hour As Long
        tm_mday As Long
        tm_mon As Long
        tm_year As Long
        tm_wday As Long
        tm_yday As Long
        tm_isdst As Long
End Type

Public Const EXTRA_SET_MONITOROUT_MODE = 0
Public Const EXTRA_GET_MONITOROUT_MODE = 1
Public Const EXTRA_SET_MONITOROUT_EDGEENHANCE = 2
Public Const EXTRA_GET_MONITOROUT_EDGEENHANCE = 3
Public Const EXTRA_SET_MONITOROUT_ZOOM = 4
Public Const EXTRA_GET_MONITOROUT_ZOOM = 5
Public Const EXTRA_SET_MONITOROUT_DISP_STATUS = 6
Public Const EXTRA_GET_MONITOROUT_DISP_STATUS = 7
Public Const EXTRA_MONITOROUT_PLAY = 8
Public Const EXTRA_MONITOROUT_PAUSE = 9
Public Const EXTRA_MONITOROUT_STOP = 10
Public Const EXTRA_MONITOROUT_STEP_FOWARD = 11
Public Const EXTRA_MONITOROUT_STEP_BACK = 12
Public Const EXTRA_MONITOROUT_GOTO_ANYFRAME = 13
Public Const EXTRA_MONITOROUT_GOTO_STARY = 14
Public Const EXTRA_MONITOROUT_GOTO_END = 15
Public Const EXTRA_MONITOROUT_GOTO_TRIGGER = 16
Public Const EXTRA_SET_ENABLE_MCDL = 17
Public Const EXTRA_GET_ENABLE_MCDL = 18
Public Const EXTRA_SET_ENABLE_IRIG = 19
Public Const EXTRA_GET_ENABLE_IRIG = 20
Public Const EXTRA_SET_ENABLE_PDC = 21
Public Const EXTRA_GET_ENABLE_PDC = 22
Public Const EXTRA_SET_ENABLE_RESTRICTION_TIME = 23
Public Const EXTRA_GET_ENABLE_RESTRICTION_TIME = 24
Public Const EXTRA_GET_RESTRICTION_TIME = 25
Public Const EXTRA_TRANSFER_MCDL = 26
Public Const EXTRA_TRANSFER_IRIG = 27
Public Const EXTRA_SHADING_COMPENSATION = 28
Public Const EXTRA_GET_CAMERA_ID = 29
Public Const EXTRA_SET_CAMERA_ID = 30
Public Const EXTRA_GET_ENABLE_RESET_TRIGGER = 31
Public Const EXTRA_SET_ENABLE_RESET_TRIGGER = 32
Public Const EXTRA_GET_SENSOR_BITSHIFT = 33
Public Const EXTRA_SET_SENSOR_BITSHIFT = 34
Public Const EXTRA_GET_MAX_PARTITION = 35
Public Const EXTRA_GET_PARTITION = 36
Public Const EXTRA_SET_PARTITION = 37
Public Const EXTRA_GET_PARTITION_LIST = 38
Public Const EXTRA_SET_PARTITION_LIST = 39
Public Const EXTRA_SET_LIVE_RESOLUTION = 40
Public Const EXTRA_GET_LIVE_RESOLUTION = 41
Public Const EXTRA_SET_LUT_MODE = 42
Public Const EXTRA_GET_LUT_MODE = 43
Public Const EXTRA_SET_USER_LUT_PARAMS = 44
Public Const EXTRA_GET_USER_LUT_PARAMS = 45
Public Const EXTRA_SET_USER_LUT_DATA = 46
Public Const EXTRA_GET_USER_LUT_DATA = 47
Public Const EXTRA_UPLOAD_USER_LUT = 48
Public Const EXTRA_SET_CHROMA_MODE = 49
Public Const EXTRA_GET_CHROMA_MODE = 50
Public Const EXTRA_SET_DS_SHUTTER_MODE = 51
Public Const EXTRA_GET_DS_SHUTTER_MODE = 52
Public Const EXTRA_SET_INTERFACE_INFO = 53
Public Const EXTRA_GET_INTERFACE_INFO = 54
Public Const EXTRA_SET_SHADING_MODE = 55
Public Const EXTRA_GET_SHADING_MODE = 56
Public Const EXTRA_GET_SHADING_LOCK = 57
Public Const EXTRA_TRANSFER_MCDLIRIG_STREAM = 58
Public Const EXTRA_SET_IRIG_OFFSET = 59
Public Const EXTRA_GET_IRIG_OFFSET = 60
Public Const EXTRA_SET_HARD_PARTITION = 61
Public Const EXTRA_GET_HARD_PARTITION = 62
Public Const EXTRA_GET_HEAD_INFO = 63
Public Const EXTRA_GET_HEAD_EXCHANGE = 64
Public Const EXTRA_GET_HEAD_NAME = 65
Public Const EXTRA_SET_SHUTTER_MODE = 66
Public Const EXTRA_GET_SHUTTER_MODE = 67
Public Const EXTRA_SET_II_POWER = 68
Public Const EXTRA_GET_II_POWER = 69
Public Const EXTRA_SET_II_GAIN = 70
Public Const EXTRA_GET_II_GAIN = 71
Public Const EXTRA_SET_II_GATE_SELECT = 72
Public Const EXTRA_GET_II_GATE_SELECT = 73
Public Const EXTRA_SET_II_GATE_CYCLE = 74
Public Const EXTRA_GET_II_GATE_CYCLE = 75
Public Const EXTRA_SET_II_GATE_WIDTH = 76
Public Const EXTRA_GET_II_GATE_WIDTH = 77
Public Const EXTRA_SET_II_GATE_TIMES = 78
Public Const EXTRA_GET_II_GATE_TIMES = 79
Public Const EXTRA_SET_II_GATE_DELAY = 80
Public Const EXTRA_GET_II_GATE_DELAY = 81
Public Const EXTRA_GET_II_GAIN_LIMIT = 82
Public Const EXTRA_GET_EVENT_FRAME = 84
Public Const EXTRA_SET_VARIABLE_SAVE = 85
Public Const EXTRA_SET_VARIABLE_LOAD = 86
Public Const EXTRA_SET_VARIABLE_ERASE = 87
Public Const EXTRA_GET_II_GATE_WIDTH_LIMIT = 88
Public Const EXTRA_SET_PIXEL_GAIN = 89
Public Const EXTRA_GET_PIXEL_GAIN = 90
Public Const EXTRA_SET_EDGE_ENHANCEMENT = 91
Public Const EXTRA_GET_EDGE_ENHANCEMENT = 92
Public Const EXTRA_SET_COLOR_MATRIX = 93
Public Const EXTRA_GET_COLOR_MATRIX = 94
Public Const EXTRA_SET_AUTO_EXPOSURE = 95
Public Const EXTRA_GET_AUTO_EXPOSURE = 96
Public Const EXTRA_SET_AUTO_EXPOSURE_MAXSHUTTER = 97
Public Const EXTRA_GET_AUTO_EXPOSURE_MAXSHUTTER = 98
Public Const EXTRA_GET_1FRAME_TIME = 99
Public Const EXTRA_SET_II_PROTECTION = 100
Public Const EXTRA_GET_II_PROTECTION = 101
