///////////////////////////////////////////////////////////////////
//
//	IRIG-B Generator Dummy Library
//
//			2001/6/19
//			Copyright (C) 2001 PHOTRON LIMITED
//
////////////////////////////////////////////////////////////////////

#if !defined(IRIGLIB_H__0_0_0_0_0__INCLUDED_)
#define IRIGLIB_H__0_0_0_0_0__INCLUDED_


#if IRIGLIB_EXPORTS
#define IRIGLIB_API __declspec(dllexport)
#else
#define IRIGLIB_API __declspec(dllimport)
#endif


#include <windows.h>

#define		IRIGLIB_NOERROR			(0)
#define		IRIGLIB_ERROR			(-1)
#define		IRIGLIB_UNINITIALIZE	(-2)

typedef struct {

	UINT	year;
	UCHAR	month;
	UCHAR	day;
	UINT	day_of_year;
	UCHAR	hour;
	UCHAR	minute;
	UCHAR	second;
	LONG	below_second;

} IRIGLIB_TIMECODE;

extern "C"	IRIGLIB_API	INT	IRIGlibInit();
extern "C"	IRIGLIB_API	INT	IRIGlibExit();
extern "C"	IRIGLIB_API	INT	IRIGlibGetCapturedTime(IRIGLIB_TIMECODE *time_code);
extern "C"	IRIGLIB_API	INT	IRIGlibGetEventFlag(BOOL* flag);
extern "C"	IRIGLIB_API	INT	IRIGlibResetCapture();
extern "C"	IRIGLIB_API	INT	IRIGlibWaitTriggerEvent(UINT wait);

#endif